.Const

MAX_METERS			Equ			20
MAX_LEDS			Equ			40

METER_DATA Struct 16
	lIndex			QWord		?
	lHeight			QWord		?
	lLedsOn			QWord		?
	lMaxValue		QWord		?
	lMinValue		QWord		?
	lShape			QWord		?
	lValue			QWord		?
	lWidth			QWord		?
	bVertical		QWord		?
	wndOldProc		WNDPROC		?
	hWndMeter		HWND 		?
	hWndOwner		HWND 		?
	hBrush			HBRUSH		?
	hLedOnBrush		HBRUSH		?
	hLedArray		HANDLE		MAX_LEDS Dup(?)
METER_DATA EndS


.Data?

.Data

lRSMeters			QWord		0
lRSMHeight			QWord		6
lRSMWidth			QWord		10
hRSMLabelArray		QWord		40 Dup(0)
hLedOffBrush		HBRUSH		NULL


include ECProtos.inc ; .Code

CreateMeter Proc FastCall Frame Uses Rbx Rdi Rsi hWndOwner:HWND, x:QWord, y:QWord, lFlags:QWord
	Local dwStyle:QWord, dwExStyle:QWord, sz:SIZEL

	Mov hWndOwner, Rcx
	Mov	x, Rdx
	Mov y, R8
	Mov lFlags, R9

	.If hLedOffBrush == NULL
		Invoke GetSysColor, COLOR_BTNFACE
		Sub Rax, 00404040H
		Invoke CreateSolidBrush, Rax
		Mov hLedOffBrush, Rax
	.EndIf
	Invoke GetFreeIndex
	Cmp Rax, (-1)
	Jne @F
L2:	Xor Rax, Rax
	Ret
@@:	Lea Rsi, hRSMLabelArray
	Mov Rbx, Rax ;Push Rax
	Shl Rax, 3
	Add Rsi, Rax
	Invoke GlobalAlloc, GPTR, SizeOf METER_DATA
	Mov Rcx, Rbx ;Pop Rcx
	Or Rax, Rax
	Jz L2
	Mov QWord Ptr [Rsi], Rax
	Mov Rsi, Rax
	Mov [Rsi].METER_DATA.lIndex, Rcx
	Mov Rax, lRSMHeight
	Mov [Rsi].METER_DATA.lHeight, Rax
	Mov Rax, lRSMWidth
	Mov [Rsi].METER_DATA.lWidth, Rax
	Mov Rax, hWndOwner
	Mov [Rsi].METER_DATA.hWndOwner, Rax
	Mov Rax, lFlags
	Mov Rdx, Rax
	And Rdx, 007FH
	Mov [Rsi].METER_DATA.lShape, Rdx
	.If (Rax & RSMETER_VERTICAL)
		Mov [Rsi].METER_DATA.bVertical, TRUE
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Dec [Rsi].METER_DATA.lHeight
		.EndIf
	.Else
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Dec [Rsi].METER_DATA.lWidth
		.EndIf
	.EndIf
	Mov dwStyle, (WS_CHILD Or WS_VISIBLE)
	Mov dwExStyle, 0
	.If Rax == RSMETER_INSET
		Or dwExStyle, WS_EX_STATICEDGE
	.ElseIf Rax == RSMETER_RAISED
		Or dwExStyle, WS_EX_DLGMODALFRAME
	.ElseIf Rax == RSMETER_BORDER
		Or dwStyle, WS_BORDER
	.EndIf
	Invoke GetParentSize, Addr sz
	ECInvoke CreateWindowEx, 0, TextStr("STATIC"), NULL, (WS_CHILD OR WS_VISIBLE), x, y, sz.x, sz.y, hWndOwner, 0, App.Instance, NULL
	Mov [Rsi].METER_DATA.hWndMeter, Rax
	Lea Rbx, [Rsi].METER_DATA.hLedArray
	Mov Rdi, 1
	Inc lRSMeters
	Invoke CreateSolidBrush, 00FFFF00H
	Mov [Rsi].METER_DATA.hLedOnBrush, Rax
	Mov x, 0
	Mov y, 0
@@:	Invoke CreateWindowEx, dwExStyle, TextStr("STATIC"), NULL, dwStyle, x, y, [Rsi].METER_DATA.lWidth, [Rsi].METER_DATA.lHeight, [Rsi].METER_DATA.hWndMeter, Rdi, App.Instance, NULL
	Or Rax, Rax
	Jz @F
	Mov QWord Ptr [Rbx], Rax
	.If [Rsi].METER_DATA.wndOldProc == NULL
		Invoke GetWindowLongPtr, Rax, GWLP_WNDPROC
		Mov [Rsi].METER_DATA.wndOldProc, Rax
	.EndIf
	Invoke SetWindowLongPtr, QWord Ptr [Rbx], GWLP_USERDATA, Rsi
	Invoke SetWindowLongPtr, QWord Ptr [Rbx], GWLP_WNDPROC, Addr wndLedsProc
	.If [Rsi].METER_DATA.bVertical
		Mov Rax, [Rsi].METER_DATA.lHeight
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Inc Rax
		.EndIf
		Add y, Rax
	.Else
		Mov Rax, [Rsi].METER_DATA.lWidth
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Inc Rax
		.EndIf
		Add x, Rax
	.EndIf
	Add Rbx, 8
	Inc Rdi
	Cmp Rdi, (MAX_LEDS + 1)
	Jb @B
	Return [Rsi].METER_DATA.lIndex
@@:	Invoke DestroyMeter, [Rsi].METER_DATA.lIndex
	Return (-1)
CreateMeter EndP

DestroyMeter Proc FastCall Frame Uses Rbx Rdi Rsi lIndex:QWord
	Mov lIndex, Rcx

	.If SQWord Ptr lIndex >= 0
		Lea Rsi, hRSMLabelArray
		Mov Rax, lIndex
		Shl Rax, 3
		Add Rsi, Rax
		Mov Rbx, Rsi ;Push Rsi
		Mov Rsi, [Rsi]
		Or Rsi, Rsi
		Jz @F
		Lea Rsi, [Rsi].METER_DATA.hLedArray
		Mov Rdi, MAX_LEDS
		.While Rdi
			.If QWord Ptr [Rsi]
				Invoke DestroyWindow, QWord Ptr [Rsi]
				Mov QWord Ptr [Rsi], 0
				Add Rsi, 8
			.EndIf
			Dec Rdi
		.EndW
		Mov Rsi, Rbx ;Pop Rsi
		Invoke GlobalFree, QWord Ptr [Rsi]
		Mov QWord Ptr [Rsi], 0
		Dec lRSMeters
		.If Zero?
			Invoke DeleteObject, hLedOffBrush
			Mov hLedOffBrush, NULL
		.EndIf
		Return TRUE
	.EndIf
@@:	Xor Rax, Rax
	Ret
DestroyMeter EndP

GetFreeIndex Proc FastCall Private Frame Uses Rsi
	Lea Rsi, hRSMLabelArray
	Xor Rcx, Rcx
	.While (Rcx < SDWord Ptr MAX_METERS)
		.If (QWord Ptr [Esi] == 0)
			Mov Rax, Rcx
			Jmp @F
		.EndIf
		Add Rsi, 8
		Inc Rcx
	.EndW
	Mov Rax, (-1)
@@:	Ret
GetFreeIndex EndP

;On enter Rsi = Pointer to data
GetParentSize Proc FastCall Private Frame Uses Rdi lpszSize:QWord
	Mov lpszSize, Rcx

	Mov Rdi, lpszSize
	.If [Rsi].METER_DATA.bVertical
		Mov Rax, [Rsi].METER_DATA.lWidth
		Mov [Rdi].SIZEL.x, Eax
		Mov Rax, [Rsi].METER_DATA.lHeight
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Inc Rax
		.EndIf
		Mov Rcx, MAX_LEDS
		Mul Rcx
		Mov [Rdi].SIZEL.y, Eax
	.Else
		Mov Rax, [Rsi].METER_DATA.lHeight
		Mov [Rdi].SIZEL.y, Eax
		Mov Rax, [Rsi].METER_DATA.lWidth
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Inc Rax
		.EndIf
		Mov Rcx, MAX_LEDS
		Mul Rcx
		Mov [Rdi].SIZEL.x, Eax
	.EndIf
	Ret
GetParentSize EndP

;On enter Rsi = Pointer to data
ResizeMeter Proc FastCall Private Frame Uses Rbx Rdi
	Local rc:RECT

	Lea Rdi, [Rsi].METER_DATA.hLedArray
	Invoke GetWindowRect, QWord Ptr [Rdi], Addr rc
	Invoke ScreenToClient, [Rsi].METER_DATA.hWndMeter, Addr rc
	Mov Rbx, MAX_LEDS
	.While Rbx
		Invoke MoveWindow, QWord Ptr [Rdi], rc.left, rc.top, [Rsi].METER_DATA.lWidth, [Rsi].METER_DATA.lHeight, TRUE
		Add Rdi, 8
		.If [Rsi].METER_DATA.bVertical
			Mov Rax, [Rsi].METER_DATA.lHeight
			.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
				Inc Rax
			.EndIf
			Add rc.top, Eax
		.Else
			Mov Rax, [Rsi].METER_DATA.lWidth
			.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
				Inc Rax
			.EndIf
			Add rc.left, Eax
		.EndIf
		Dec Rbx
	.EndW
	Ret
ResizeMeter EndP

SetMeterColor Proc FastCall Frame Uses Rsi lIndex:QWord, crColor:QWord
	Mov lIndex, Rcx
	Mov crColor, Rdx

	.If SQWord Ptr lIndex >= 0
		Lea Rsi, hRSMLabelArray
		Mov Rax, lIndex
		Shl Rax, 3
		Add Rsi, Rax
		Mov Rsi, [Rsi]
		.If Rsi
			Invoke DeleteObject, [Rsi].METER_DATA.hLedOnBrush
			Mov Rax, crColor
			Test Eax, 80000000H
			.If !Zero?
				And Eax, 00FFFFFFH
				Invoke GetSysColor, Rax
			.EndIf
			Invoke CreateSolidBrush, Rax
			Mov [Rsi].METER_DATA.hLedOnBrush, Rax
		.EndIf
		Mov Rax, TRUE
		Jmp @F
	.EndIf
	Xor Rax, Rax
@@:	Ret
SetMeterColor EndP

SetMeterHeight Proc FastCall Frame Uses Rsi lIndex:QWord, lHeight:QWord
	Local sz:SIZEL

	Mov lIndex, Rcx
	Mov lHeight, Rdx

	.If SQWord Ptr lIndex >= 0
		Lea Rsi, hRSMLabelArray
		Mov Rax, lIndex
		Shl Rax, 3
		Add Rsi, Rax
		Mov Rsi, [Rsi]
		Mov Rax, lHeight
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Dec Rax
		.EndIf
		.If Rax != [Rsi].METER_DATA.lHeight
			Mov [Rsi].METER_DATA.lHeight, Rax
			Invoke GetParentSize, Addr sz
			ECInvoke SetWindowPos, [Rsi].METER_DATA.hWndMeter, NULL, 0, 0, sz.x, sz.y, (SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED)
			Invoke ResizeMeter
			Return TRUE
		.EndIf
	.EndIf
	Xor Rax, Rax
	Ret
SetMeterHeight EndP

SetMeterMaxValue Proc FastCall Frame Uses Rsi lIndex:QWord, lMaxValue:QWord
	Mov lIndex, Rcx
	Mov lMaxValue, Rdx

	.If (SQWord Ptr lIndex >= 0)
		Lea Rsi, hRSMLabelArray
		Mov Rax, lIndex
		Shl Rax, 3
		Add Rsi, Rax
		Mov Rsi, [Rsi]
		Mov Rax, lMaxValue
		Mov [Rsi].METER_DATA.lMaxValue, Rax
		Return TRUE
	.EndIf
	Xor Rax, Rax
	Ret
SetMeterMaxValue EndP

SetMeterValue Proc FastCall Frame Uses Rbx Rdi Rsi lIndex:QWord, lValue:QWord
	Local lLedsOn:QWord

	Mov lIndex, Rcx
	Mov lValue, Rdx

	.If (SQWord Ptr lIndex >= 0)
		Lea Rsi, hRSMLabelArray
		Mov Rax, lIndex
		Shl Rax, 3
		Add Rsi, Rax
		Mov Rsi, [Rsi]
		Mov Rax, lValue
		.If (SQWord Ptr Rax < 0)
			Xor Rax, Rax
		.ElseIf Rax > SQWord Ptr [Rsi].METER_DATA.lMaxValue
			Mov Rax, [Rsi].METER_DATA.lMaxValue
		.EndIf
		Mov [Rsi].METER_DATA.lValue, Rax
		Mov Rax, [Rsi].METER_DATA.lMaxValue
		Xor Rdx, Rdx
		Mov Rcx, MAX_LEDS
		Div Rcx
		Mov Rcx, Rax
		Mov Rax, [Rsi].METER_DATA.lValue
		Xor Rdx, Rdx
		Or Rcx, Rcx
		Jz @F
		Div Rcx
		Shr Rcx, 1
		Mov Rbx, Rcx
		Shr Rcx, 1
		Add Rbx, Rcx
		Cmp Rdx, Rbx
		Jl @F
		Inc Rax
@@:		Mov [Rsi].METER_DATA.lLedsOn, Rax
		Mov lLedsOn, Rax
		Lea Rbx, [Rsi].METER_DATA.hLedArray
		Xor Rdi, Rdi
		Or Rax, Rax
		Jz @F
		.While (Rdi <= lLedsOn)
			Mov Rax, [Rsi].METER_DATA.hLedOnBrush
			Mov [Rsi].METER_DATA.hBrush, Rax
			.If QWord Ptr [Rbx]
				Invoke InvalidateRect, QWord Ptr [Rbx], NULL, FALSE
				Invoke SendMessage, QWord Ptr [Rbx], WM_PAINT, 0, 0
			.EndIf
			Add Rbx, 8
			Inc Rdi
		.EndW
@@:		.While (Rdi < MAX_LEDS)
			Mov Rax, hLedOffBrush
			Mov [Rsi].METER_DATA.hBrush, Rax
			.If QWord Ptr [Rbx]
				Invoke InvalidateRect, QWord Ptr [Rbx], NULL, FALSE
				Invoke SendMessage, QWord Ptr [Rbx], WM_PAINT, 0, 0
			.EndIf
			Add Rbx, 8
			Inc Rdi
		.EndW
		Return TRUE
	.EndIf
	Xor Rax, Rax
	Ret
SetMeterValue EndP

SetMeterWidth Proc FastCall Frame Uses Rsi lIndex:QWord, lWidth:QWord
	Local sz:SIZEL

	Mov lIndex, Rcx
	Mov lWidth, Rdx

	.If (SQWord Ptr lIndex >= 0)
		Lea Rsi, hRSMLabelArray
		Mov Rax, lIndex
		Shl Rax, 3
		Add Rsi, Rax
		Mov Rsi, [Rsi]
		Mov Rax, lWidth
		.If [Rsi].METER_DATA.lShape == RSMETER_FLAT
			Dec Rax
		.EndIf
		.If Rax != [Rsi].METER_DATA.lWidth
			Mov [Rsi].METER_DATA.lWidth, Rax
			Invoke GetParentSize, Addr sz
			ECInvoke SetWindowPos, [Rsi].METER_DATA.hWndMeter, NULL, 0, 0, sz.x, sz.y, (SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED)
			Invoke ResizeMeter
			Mov Rax, TRUE
			Jmp @F
		.EndIf
	.EndIf
	Xor Rax, Rax
@@:	Ret
SetMeterWidth EndP

wndLedsProc Proc FastCall Private Frame Uses Rsi hWnd:HWND, uMsg:QWord, wParam:WPARAM, lParam:LPARAM
	Local ps:PAINTSTRUCT

    Mov hWnd, Rcx
    Mov uMsg, Rdx
    Mov wParam, R8
    Mov lParam, R9

	Invoke GetWindowLongPtr, hWnd, GWLP_USERDATA
	Mov Rsi, Rax
	.If uMsg == WM_ERASEBKGND
		Mov Rax, TRUE
		Jmp @F
	.ElseIf uMsg == WM_PAINT
		Invoke BeginPaint, hWnd, Addr ps
		Invoke GetClientRect, hWnd, Addr ps.rcPaint
		Invoke FillRect, ps.hdc, Addr ps.rcPaint, [Rsi].METER_DATA.hBrush
		Invoke EndPaint, hWnd, Addr ps
		Xor Rax, Rax
		Jmp @F
	.EndIf
	Invoke CallWindowProc, [Rsi].METER_DATA.wndOldProc, hWnd, uMsg, wParam, lParam
@@:	Ret
wndLedsProc EndP
